drop_schema () {
export MYSQL_PWD=$2;
mysql --user=$1 << EOF
SET GLOBAL local_infile=1;
DROP DATABASE moviedata;
EOF
}

create_schema () {
export MYSQL_PWD=$2;
mysql --user=$1 << EOF
SET GLOBAL local_infile=1;
CREATE DATABASE moviedata;
USE moviedata;
create table movie(movie_id INT,title VARCHAR(100),budget INT,gross INT,release_date DATE,genre VARCHAR(50),rating INT,summary VARCHAR(500));
EOF
}

insert_data () {
export MYSQL_PWD=$2;
mysql --user=$1 moviedata << EOF
SET GLOBAL local_infile=1;
LOAD DATA LOCAL INFILE 'data$i.csv' INTO TABLE movie FIELDS TERMINATED BY ',' ENCLOSED BY '"' LINES TERMINATED BY '\n' IGNORE 1 ROWS;
EOF
}

echo "-->> Start, drop schema into mysql.";
drop_schema $1 $2
echo "-->> End, drop schema into mysql.";
echo "-->> Start, create schema into mysql.";
create_schema $1 $2
echo "-->> End, create schema into mysql.";

rm -r data*

echo "-->> Start, client inserting data into mysql.";
# run script in loop
for i in $(seq 1 5)
do
	# wait loop here for 30 second
	sleep 90
	  echo "-->> Download data file - data$i.csv";
    wget http://$3:$4/download/data$i.csv
  	insert_data $1 $2 $i;
    echo "-->> Insert data into mysql - $i";
done

echo "-->> End, client inserting data into mysql.";

# sh mysqlrun.sh <mysql_username> <mysql_password> <client_ip> <client_port>
# sh mysqlrun.sh root root 192.168.225.48 8080
