#!/bin/bash

echo "-->> clean hadoop old space.";
hadoop fs -rm -r /moviedata
hadoop fs -mkdir /moviedata/

echo "-->> create mysql database password file for easy login with sqoop job.";
echo -n $2 > db.password
hadoop fs -copyFromLocal db.password /moviedata/

echo "-->> delete sqoop job if exist and create new sqoop job.";
sqoop job --delete moviejob
sqoop job --create moviejob -- import --connect jdbc:mysql://localhost/moviedata --username $1 --password-file /moviedata/db.password --table movie --target-dir /moviedata --incremental append --check-column movie_id -m 1

echo "-->> Start sqoop script.";
for i in $(seq 0 10)
do
	sqoop job -exec moviejob;
	if (hadoop fs -test -e /moviedata/part-m-0000$i); then
		echo "-->> file exist on hdfs. part-m-0000$i";
		n=n+1;
		row=$(hadoop fs -cat /moviedata/part-m-0000$i | wc -l)
		curl -X POST http://$3:$4/upload/$row
		echo "-->> upload append data value on client system. row: $row";
	else
		echo "-->> file not exist on hdfs. part-m-0000$i";
		curl -X POST http://$3:$4/upload/0
		echo "-->> upload append data value on client system. row: 0";
	fi
done
echo "-->> End sqoop script.";

# sh sqooprun.sh <mysql_username> <mysql_password> <client_ip> <client_port>
# sh sqooprun.sh root root 192.168.225.48 8080
